% apriori_floating.m
% nakao,yamamoto,watanabe _ł̍s
% F, A1, A2, A3, A4  floating ō쐬

function [F,A1,A2,A3,A4]=apriori_floating(Nx,Ny,nu,width,height);

hx=width/Nx;
hy=height/Ny;

hx2=hx^2;
hy2=hy^2;

dim_phihat=(2*Nx+1)*(2*Ny+1);
dim_phi=(2*Nx-1)*(2*Ny-1);
dim_psi=(Nx+1)*(Ny+1)-1;

% beta ̐ݒ
nnode_y1=Ny+1;
beta=4*ones(dim_psi+1,1);
for i=2:2:2*Nx-2
    beta(i*nnode_y1/2+1)=2;
    beta(i*nnode_y1/2+Ny+1)=2;
end
for j=2:2:2*Ny-2
    beta(j/2+1)=2;
    beta(Nx*nnode_y1+j/2+1)=2;
end
beta(1)=1;
beta(Ny+1)=1;
beta(Nx*nnode_y1+1)=1;
beta(Nx*nnode_y1+Ny+1)=1;

% s Lhat0 ̍쐬
Lhat0=hx*hy/900*[16 -4  1 -4   8  -2  -2   8   4; 
                 -4 16 -4  1   8   8  -2  -2   4;
                  1 -4 16 -4  -2   8   8  -2   4; 
                 -4  1 -4 16  -2  -2   8   8   4; 
                  8  8 -2 -2  64   4 -16   4  32;
                 -2  8  8 -2   4  64   4 -16  32;
                 -2 -2  8  8 -16   4  64   4  32;
                  8 -2 -2  8   4 -16   4  64  32;
                  4  4  4  4  32  32  32  32 256];
% s Lhat ̍쐬
Lhat=assem_floating1(Lhat0,Nx,Ny);

% s L ̍쐬
L=delete_boundary(Lhat,Nx,Ny);

% s D00 ̍쐬
D00=hx/(90*hy)*[28  -7  -1   4   14   8    2 -32  -16;
                -7  28   4  -1   14 -32    2   8  -16;
                -1   4  28  -7    2 -32   14   8  -16;
                 4  -1  -7  28    2   8   14 -32  -16;
                14  14   2   2  112 -16   16 -16 -128;
                 8 -32 -32   8  -16  64  -16 -16   32;
                 2   2  14  14   16 -16  112 -16 -128;
               -32   8   8 -32  -16 -16  -16  64   32;
               -16 -16 -16 -16 -128  32 -128  32  256];
D00=D00+hy/(90*hx)*[28   4  -1  -7 -32    2   8   14  -16;
                     4  28  -7  -1 -32   14   8    2  -16;
                    -1  -7  28   4   8   14 -32    2  -16;
                    -7  -1   4  28   8    2 -32   14  -16;
                   -32 -32   8   8  64  -16 -16  -16   32;
                     2  14  14   2 -16  112 -16   16 -128;
                     8   8 -32 -32 -16  -16  64  -16   32;
                    14   2   2  14 -16   16 -16  112 -128;
                   -16 -16 -16 -16  32 -128  32 -128  256];
           
% s D0 ̍쐬
D0=delete_boundary(assem_floating1(D00,Nx,Ny),Nx,Ny);

% s Dhatxx0 ̍쐬
Dhatxx0=hy/(90*hx)*[28   4  -1  -7 -32    2   8   14  -16;
                     4  28  -7  -1 -32   14   8    2  -16;
                    -1  -7  28   4   8   14 -32    2  -16;
                    -7  -1   4  28   8    2 -32   14  -16;
                   -32 -32   8   8  64  -16 -16  -16   32;
                     2  14  14   2 -16  112 -16   16 -128;
                     8   8 -32 -32 -16  -16  64  -16   32;
                    14   2   2  14 -16   16 -16  112 -128;
                   -16 -16 -16 -16  32 -128  32 -128  256];

% s Dhatxx ̍쐬
Dhatxx=assem_floating1(Dhatxx0,Nx,Ny);

% s Dhatxy0 ̍쐬
Dhatxy0=1/36*[9  -3  -1   3  12   4   4 -12 -16;
              3  -9  -3   1 -12  12  -4  -4  16;
             -1   3   9  -3   4 -12  12   4 -16;
             -3   1   3  -9  -4  -4 -12  12  16;
            -12  12   4  -4   0 -16   0  16   0;
              4 -12  12  -4 -16   0  16   0   0;
              4  -4 -12  12   0  16   0 -16   0;
             12  -4   4 -12  16   0 -16   0   0;
            -16  16 -16  16   0   0   0   0   0];
     
% s Dhatxy ̍쐬
Dhatxy=assem_floating1(Dhatxy0,Nx,Ny);

% s Dhatyy0 ̍쐬
Dhatyy0=hx/(90*hy)*[28  -7  -1   4   14   8    2 -32  -16;
                    -7  28   4  -1   14 -32    2   8  -16;
                    -1   4  28  -7    2 -32   14   8  -16;
                     4  -1  -7  28    2   8   14 -32  -16;
                    14  14   2   2  112 -16   16 -16 -128;
                     8 -32 -32   8  -16  64  -16 -16   32;
                     2   2  14  14   16 -16  112 -16 -128;
                   -32   8   8 -32  -16 -16  -16  64   32;
                   -16 -16 -16 -16 -128  32 -128  32 256];
            
% s Dhatyy ̍쐬
Dhatyy=assem_floating1(Dhatyy0,Nx,Ny);

% s Dxx ̍쐬
Dxx=delete_boundary(Dhatxx,Nx,Ny);

% s Dxy ̍쐬
Dxy=delete_boundary(Dhatxy,Nx,Ny);

% s Dyy ̍쐬
Dyy=delete_boundary(Dhatyy,Nx,Ny);

% s Kx0 ̍쐬
Kx0=hy/180*[-12   4  -1   3 -16   2   4  -6  -8;
             -4  12  -3   1  16   6  -4  -2   8;
              1  -3  12  -4  -4   6  16  -2   8; 
              3  -1   4 -12   4   2 -16  -6  -8;
             16 -16   4  -4   0  -8   0   8   0;
             -2   6   6  -2   8  48   8 -16  64;
             -4   4 -16  16   0  -8   0   8   0;
             -6   2   2  -6  -8  16  -8 -48 -64;
              8  -8  -8   8   0 -64   0  64   0];
          
% s Kx ̍쐬
Kx=assem_floating2(Kx0,Nx,Ny);

% s Ky0 ̍쐬
Ky0=hx/180*[-12   3  -1  4   -6   4   2 -16  -8;
              3 -12   4  -1  -6 -16   2   4  -8;
              1  -4  12  -3  -2  16   6  -4   8;
             -4   1  -3  12  -2  -4   6  16   8;
             -6  -6   2   2 -48  -8  16  -8 -64;
             -4  16 -16   4   8   0  -8   0   0;
             -2  -2   6   6 -16   8  48   8  64;
             16  -4   4 -16   8   0  -8   0   0;
              8   8  -8  -8  64   0 -64   0   0];
          
% s Ky ̍쐬
Ky=assem_floating2(Ky0,Nx,Ny);

% s Fhatxx0 ̍쐬
Fhatxx0=hy/(6*hx)*[ 1 -1  0  0;
                   -1  1  0  0;
                    0  0  1 -1;
                    0  0 -1  1;
                    0  0  0  0;
                   -2  2  2 -2;
                    0  0  0  0;
                    2 -2 -2  2;
                    0  0  0  0];

% s Fhatxx ̍쐬
Fhatxx=assem_floating3(Fhatxx0,beta,Nx,Ny);

% s Fhatxy0 ̍쐬
Fhatxy0=1/36*[  5   1  -1  -5;
               -1  -5   5   1;
               -1  -5   5   1;
                5   1  -1  -5;
               -4   4  -4   4;
               -4 -20  20   4;
               -4   4  -4   4;
               20   4  -4 -20;
              -16  16 -16  16];

% s Fhatxy ̍쐬
Fhatxy=assem_floating3(Fhatxy0,beta,Nx,Ny);

% s Fhatyx0 ̍쐬
Fhatyx0=1/36*[  5  -5  -1   1;
                5  -5  -1   1;
               -1   1   5  -5;
               -1   1   5  -5;
               20 -20  -4   4;
               -4   4  -4   4;
               -4   4  20 -20;
               -4   4  -4   4;
              -16  16 -16  16];

% s Fhatyx ̍쐬
Fhatyx=assem_floating3(Fhatyx0,beta,Nx,Ny);

% s Fhatyy0 ̍쐬
Fhatyy0=hx/(6*hy)*[ 1  0  0 -1;
                    0  1 -1  0;
                    0 -1  1  0;
                   -1  0  0  1;
                    2  2 -2 -2;
                    0  0  0  0;
                   -2 -2  2  2;
                    0  0  0  0;
                    0  0  0  0];

% s Fhatyy ̍쐬
Fhatyy=assem_floating3(Fhatyy0,beta,Nx,Ny);

% s Dtilde0 ̍쐬
Dtilde0=1/(6*hx*hy)*[2*hx2+2*hy2    hx2-2*hy2     -hx2-hy2   -2*hx2+hy2;
                       hx2-2*hy2  2*hx2+2*hy2   -2*hx2+hy2     -hx2-hy2;
                        -hx2-hy2   -2*hx2+hy2  2*hx2+2*hy2    hx2-2*hy2;
                      -2*hx2+hy2     -hx2-hy2    hx2-2*hy2  2*hx2+2*hy2];
                  
% s Dtilde ̍쐬
Dtilde=assem_floating4(Dtilde0,beta,Nx,Ny);

% s Ex0 ̍쐬
Ex0=hy/36*[-5 1 0  0  4  2  0 -10  8;
           -1 5 0  0 -4 10  0  -2 -8;
            0 0 5 -1  0 10 -4  -2 -8;
            0 0 1 -5  0  2  4 -10  8];

% s Ex ̍쐬
Ex=assem_floating5(Ex0,beta,Nx,Ny);

% s Ey0 ̍쐬
Ey0=hx/36*[-5  0 0 1 -10  0  2  4  8;
            0 -5 1 0 -10  4  2  0  8;
            0 -1 5 0  -2 -4 10  0 -8;
           -1  0 0 5  -2  0 10 -4 -8];

% s Ey ̍쐬
Ey=assem_floating5(Ey0,beta,Nx,Ny);

%                                 %
% ֐̍s쐬 ܂ %
%                                 %

% s D ̍쐬
D=[         nu*D0  zeros(dim_phi);
   zeros(dim_phi)          nu*D0];

% s E ̍쐬
E=[Ex Ey];

% s G ̍쐬
G=[ D            -E';
   -E zeros(dim_psi)];

% s invG ̍쐬
invG=inv(G);

% s Ga, Gb, Gstar ̍쐬
Ga=invG(1:2*dim_phi,1:2*dim_phi);
Gb=invG(2*dim_phi+1:2*dim_phi+dim_psi,1:2*dim_phi);
Gstar=invG(2*dim_phi+1:2*dim_phi+dim_psi,2*dim_phi+1:2*dim_phi+dim_psi);

% s invLhat ̍쐬
invLhat=inv(Lhat);

% s Mx, My ̍쐬
Mx=Kx*invLhat;
My=Ky*invLhat;

% s invL ̍쐬
invL=inv(L);

% s F ̍쐬
F=[         invL  zeros(dim_phi);
   zeros(dim_phi)          invL];

% s Q1 ̍쐬
tmpQ1=D0-Mx*Kx'-My*Ky';
Q1=[         tmpQ1 zeros(dim_phi);
    zeros(dim_phi)         tmpQ1];

% s A1 ̍쐬
A1=Ga*Q1*Ga;

% s Ehatxx, Ehatxy, Ehatyy ̍쐬
Ehatxx=Mx*Dhatxx*Mx';
Ehatxy=Mx*Dhatxy*My';
Ehatyy=My*Dhatyy*My';

% s E1 ̍쐬
tmpE1=Ehatxx+Ehatxy+Ehatxy'+Ehatyy;
E1=[         tmpE1 zeros(dim_phi);
    zeros(dim_phi)         tmpE1];

% s E2 ̍쐬
E2=[(Mx*Fhatxx+My*Fhatyx)*Gb;
    (Mx*Fhatxy+My*Fhatyy)*Gb];

% s E3 ̍쐬
tmpE3=-(Kx*invLhat*Kx'+Ky*invLhat*Ky')*invL;
E3=[        tmpE3  zeros(dim_phi);
    zeros(dim_phi)         tmpE3];

% s A2 ̍쐬
A2=nu^2*Ga'*E1*Ga-nu*Ga*E2-nu*(Ga*E2)'+nu*Ga*E3+nu*(Ga*E3)'+Gb'*E*F+(Gb'*E*F)'+Gb'*Dtilde*Gb+F;

% s Q3 ̍쐬
Q3=[Dxx  Dxy;
    Dxy' Dyy];

% s A3 ̍쐬
A3=Ga*Q3*Ga;

% s A4 ̍쐬
A4=Gb'*E*F+(Gb'*E*F)'+Gb'*Dtilde*Gb+F;
